diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/ssl/ssl_cert.c openssl-1.0.1f-rlwekex/ssl/ssl_cert.c
--- openssl-1.0.1f/ssl/ssl_cert.c	2014-01-06 14:47:42.000000000 +0100
+++ openssl-1.0.1f-rlwekex/ssl/ssl_cert.c	2014-10-16 12:38:15.000000000 +0200
@@ -269,10 +269,21 @@
 			goto err;
 			}
 		}
 	ret->ecdh_tmp_cb = cert->ecdh_tmp_cb;
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+	if (cert->rlwe_tmp)
+		{
+		ret->rlwe_tmp = RLWE_PAIR_dup(cert->rlwe_tmp);
+		if (ret->rlwe_tmp == NULL)
+			{
+			SSLerr(SSL_F_SSL_CERT_DUP, ERR_R_RLWE_LIB);
+			goto err;
+			}
+		}
+#endif
 
 	for (i = 0; i < SSL_PKEY_NUM; i++)
 		{
 		if (cert->pkeys[i].x509 != NULL)
 			{
@@ -327,11 +338,11 @@
 	 */
 	ssl_cert_set_default_md(ret);
 
 	return(ret);
 	
-#if !defined(OPENSSL_NO_DH) || !defined(OPENSSL_NO_ECDH)
+#if !defined(OPENSSL_NO_DH) || !defined(OPENSSL_NO_ECDH) || !defined(OPENSSL_NO_RLWEKEX)
 err:
 #endif
 #ifndef OPENSSL_NO_RSA
 	if (ret->rsa_tmp != NULL)
 		RSA_free(ret->rsa_tmp);
@@ -342,10 +353,14 @@
 #endif
 #ifndef OPENSSL_NO_ECDH
 	if (ret->ecdh_tmp != NULL)
 		EC_KEY_free(ret->ecdh_tmp);
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+	if (ret->rlwe_tmp != NULL)
+		RLWE_PAIR_free(ret->rlwe_tmp);
+#endif
 
 	for (i = 0; i < SSL_PKEY_NUM; i++)
 		{
 		if (ret->pkeys[i].x509 != NULL)
 			X509_free(ret->pkeys[i].x509);
@@ -384,10 +399,13 @@
 	if (c->dh_tmp) DH_free(c->dh_tmp);
 #endif
 #ifndef OPENSSL_NO_ECDH
 	if (c->ecdh_tmp) EC_KEY_free(c->ecdh_tmp);
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+	if (c->rlwe_tmp) RLWE_PAIR_free(c->rlwe_tmp);
+#endif
 
 	for (i=0; i<SSL_PKEY_NUM; i++)
 		{
 		if (c->pkeys[i].x509 != NULL)
 			X509_free(c->pkeys[i].x509);
@@ -494,10 +512,16 @@
 #endif
 #ifndef OPENSSL_NO_ECDH
 	if (sc->peer_ecdh_tmp != NULL)
 		EC_KEY_free(sc->peer_ecdh_tmp);
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+	if (sc->peer_rlwepub_tmp != NULL)
+		RLWE_PUB_free(sc->peer_rlwepub_tmp);
+	if (sc->peer_rlwerec_tmp != NULL)
+		RLWE_REC_free(sc->peer_rlwerec_tmp);
+#endif
 
 	OPENSSL_free(sc);
 	}
 
 int ssl_set_peer_cert_type(SESS_CERT *sc,int type)
diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/ssl/ssl_ciph.c openssl-1.0.1f-rlwekex/ssl/ssl_ciph.c
--- openssl-1.0.1f/ssl/ssl_ciph.c	2014-01-06 14:47:42.000000000 +0100
+++ openssl-1.0.1f-rlwekex/ssl/ssl_ciph.c	2014-10-16 12:38:15.000000000 +0200
@@ -248,10 +248,11 @@
 
 	{0,SSL_TXT_kECDHr,0,  SSL_kECDHr,0,0,0,0,0,0,0,0},
 	{0,SSL_TXT_kECDHe,0,  SSL_kECDHe,0,0,0,0,0,0,0,0},
 	{0,SSL_TXT_kECDH,0,   SSL_kECDHr|SSL_kECDHe,0,0,0,0,0,0,0,0},
 	{0,SSL_TXT_kEECDH,0,  SSL_kEECDH,0,0,0,0,0,0,0,0},
+	{0,SSL_TXT_kRLWE,0,   SSL_kRLWE,0,0,0,0,0,0,0,0},
 	{0,SSL_TXT_ECDH,0,    SSL_kECDHr|SSL_kECDHe|SSL_kEECDH,0,0,0,0,0,0,0,0},
 
         {0,SSL_TXT_kPSK,0,    SSL_kPSK,  0,0,0,0,0,0,0,0},
 	{0,SSL_TXT_kSRP,0,    SSL_kSRP,  0,0,0,0,0,0,0,0},
 	{0,SSL_TXT_kGOST,0, SSL_kGOST,0,0,0,0,0,0,0,0},
@@ -272,10 +273,11 @@
 	{0,SSL_TXT_aGOST,0,0,SSL_aGOST94|SSL_aGOST01,0,0,0,0,0,0,0},
 
 	/* aliases combining key exchange and server authentication */
 	{0,SSL_TXT_EDH,0,     SSL_kEDH,~SSL_aNULL,0,0,0,0,0,0,0},
 	{0,SSL_TXT_EECDH,0,   SSL_kEECDH,~SSL_aNULL,0,0,0,0,0,0,0},
+	{0,SSL_TXT_RLWE,0,    SSL_kRLWE,~SSL_aNULL,0,0,0,0,0,0,0},
 	{0,SSL_TXT_NULL,0,    0,0,SSL_eNULL, 0,0,0,0,0,0},
 	{0,SSL_TXT_KRB5,0,    SSL_kKRB5,SSL_aKRB5,0,0,0,0,0,0,0},
 	{0,SSL_TXT_RSA,0,     SSL_kRSA,SSL_aRSA,0,0,0,0,0,0,0},
 	{0,SSL_TXT_ADH,0,     SSL_kEDH,SSL_aNULL,0,0,0,0,0,0,0},
 	{0,SSL_TXT_AECDH,0,   SSL_kEECDH,SSL_aNULL,0,0,0,0,0,0,0},
@@ -1590,10 +1592,13 @@
 		kx="ECDH/ECDSA";
 		break;
 	case SSL_kEECDH:
 		kx="ECDH";
 		break;
+	case SSL_kRLWE:
+		kx="RLWE";
+		break;
 	case SSL_kPSK:
 		kx="PSK";
 		break;
 	case SSL_kSRP:
 		kx="SRP";
diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/ssl/ssl_err.c openssl-1.0.1f-rlwekex/ssl/ssl_err.c
--- openssl-1.0.1f/ssl/ssl_err.c	2014-01-06 14:47:42.000000000 +0100
+++ openssl-1.0.1f-rlwekex/ssl/ssl_err.c	2014-10-16 12:38:15.000000000 +0200
@@ -317,10 +317,11 @@
 {ERR_REASON(SSL_R_BAD_MESSAGE_TYPE)      ,"bad message type"},
 {ERR_REASON(SSL_R_BAD_PACKET_LENGTH)     ,"bad packet length"},
 {ERR_REASON(SSL_R_BAD_PROTOCOL_VERSION_NUMBER),"bad protocol version number"},
 {ERR_REASON(SSL_R_BAD_PSK_IDENTITY_HINT_LENGTH),"bad psk identity hint length"},
 {ERR_REASON(SSL_R_BAD_RESPONSE_ARGUMENT) ,"bad response argument"},
+{ERR_REASON(SSL_R_BAD_RLWE_PUB)          ,"bad rlwe pub"},
 {ERR_REASON(SSL_R_BAD_RSA_DECRYPT)       ,"bad rsa decrypt"},
 {ERR_REASON(SSL_R_BAD_RSA_ENCRYPT)       ,"bad rsa encrypt"},
 {ERR_REASON(SSL_R_BAD_RSA_E_LENGTH)      ,"bad rsa e length"},
 {ERR_REASON(SSL_R_BAD_RSA_MODULUS_LENGTH),"bad rsa modulus length"},
 {ERR_REASON(SSL_R_BAD_RSA_SIGNATURE)     ,"bad rsa signature"},
diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/ssl/ssl_lib.c openssl-1.0.1f-rlwekex/ssl/ssl_lib.c
--- openssl-1.0.1f/ssl/ssl_lib.c	2014-01-06 14:47:42.000000000 +0100
+++ openssl-1.0.1f-rlwekex/ssl/ssl_lib.c	2014-10-16 12:38:15.000000000 +0200
@@ -2019,10 +2019,13 @@
 	unsigned long mask_k,mask_a,emask_k,emask_a;
 	int have_ecc_cert, ecdh_ok, ecdsa_ok, ecc_pkey_size;
 #ifndef OPENSSL_NO_ECDH
 	int have_ecdh_tmp;
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+	int have_rlwe_tmp;
+#endif
 	X509 *x = NULL;
 	EVP_PKEY *ecc_pkey = NULL;
 	int signature_nid = 0, pk_nid = 0, md_nid = 0;
 
 	if (c == NULL) return;
@@ -2045,10 +2048,13 @@
 #endif
 
 #ifndef OPENSSL_NO_ECDH
 	have_ecdh_tmp=(c->ecdh_tmp != NULL || c->ecdh_tmp_cb != NULL);
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+	have_rlwe_tmp=(c->rlwe_tmp != NULL);
+#endif
 	cpk= &(c->pkeys[SSL_PKEY_RSA_ENC]);
 	rsa_enc= (cpk->x509 != NULL && cpk->privatekey != NULL);
 	rsa_enc_export=(rsa_enc && EVP_PKEY_size(cpk->privatekey)*8 <= kl);
 	cpk= &(c->pkeys[SSL_PKEY_RSA_SIGN]);
 	rsa_sign=(cpk->x509 != NULL && cpk->privatekey != NULL);
@@ -2069,12 +2075,12 @@
 	emask_a=0;
 
 	
 
 #ifdef CIPHER_DEBUG
-	printf("rt=%d rte=%d dht=%d ecdht=%d re=%d ree=%d rs=%d ds=%d dhr=%d dhd=%d\n",
-	        rsa_tmp,rsa_tmp_export,dh_tmp,have_ecdh_tmp,
+	printf("rt=%d rte=%d dht=%d ecdht=%d rlwet=%d re=%d ree=%d rs=%d ds=%d dhr=%d dhd=%d\n",
+	        rsa_tmp,rsa_tmp_export,dh_tmp,have_ecdh_tmp,have_rlwe_tmp
 		rsa_enc,rsa_enc_export,rsa_sign,dsa_sign,dh_rsa,dh_dsa);
 #endif
 	
 	cpk = &(c->pkeys[SSL_PKEY_GOST01]);
 	if (cpk->x509 != NULL && cpk->privatekey !=NULL) {
@@ -2198,10 +2204,14 @@
 		{
 		mask_k|=SSL_kEECDH;
 		emask_k|=SSL_kEECDH;
 		}
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+	mask_k|=SSL_kRLWE;
+	emask_k|=SSL_kRLWE;
+#endif
 
 #ifndef OPENSSL_NO_PSK
 	mask_k |= SSL_kPSK;
 	mask_a |= SSL_aPSK;
 	emask_k |= SSL_kPSK;
diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/ssl/ssl_locl.h openssl-1.0.1f-rlwekex/ssl/ssl_locl.h
--- openssl-1.0.1f/ssl/ssl_locl.h	2014-01-06 14:47:42.000000000 +0100
+++ openssl-1.0.1f-rlwekex/ssl/ssl_locl.h	2014-10-16 12:38:15.000000000 +0200
@@ -159,10 +159,13 @@
 #include <openssl/rsa.h>
 #endif
 #ifndef OPENSSL_NO_DSA
 #include <openssl/dsa.h>
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+#include <openssl/rlwekex.h>
+#endif
 #include <openssl/err.h>
 #include <openssl/ssl.h>
 #include <openssl/symhacks.h>
 
 #ifdef OPENSSL_BUILD_SHLIBSSL
@@ -297,10 +300,11 @@
 #define SSL_kECDHe		0x00000040L /* ECDH cert, ECDSA CA cert */
 #define SSL_kEECDH		0x00000080L /* ephemeral ECDH */
 #define SSL_kPSK		0x00000100L /* PSK */
 #define SSL_kGOST       0x00000200L /* GOST key exchange */
 #define SSL_kSRP        0x00000400L /* SRP */
+#define SSL_kRLWE		0x00000800L /* Ring Learning with Errors */
 
 /* Bits for algorithm_auth (server authentication) */
 #define SSL_aRSA		0x00000001L /* RSA auth */
 #define SSL_aDSS 		0x00000002L /* DSS auth */
 #define SSL_aNULL 		0x00000004L /* no auth (i.e. use ADH or AECDH) */
@@ -510,10 +514,13 @@
 #ifndef OPENSSL_NO_ECDH
 	EC_KEY *ecdh_tmp;
 	/* Callback for generating ephemeral ECDH keys */
 	EC_KEY *(*ecdh_tmp_cb)(SSL *ssl,int is_export,int keysize);
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+	RLWE_PAIR *rlwe_tmp;
+#endif
 
 	CERT_PKEY pkeys[SSL_PKEY_NUM];
 
 	int references; /* >1 only if SSL_copy_session_id is used */
 	} CERT;
@@ -538,10 +545,14 @@
 	DH *peer_dh_tmp; /* not used for SSL 2 */
 #endif
 #ifndef OPENSSL_NO_ECDH
 	EC_KEY *peer_ecdh_tmp;
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+	RLWE_PUB *peer_rlwepub_tmp;
+	RLWE_REC *peer_rlwerec_tmp;
+#endif
 
 	int references; /* actually always 1 at the moment */
 	} SESS_CERT;
 
 
diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/ssl/tls1.h openssl-1.0.1f-rlwekex/ssl/tls1.h
--- openssl-1.0.1f/ssl/tls1.h	2014-01-06 14:47:42.000000000 +0100
+++ openssl-1.0.1f-rlwekex/ssl/tls1.h	2014-10-16 12:38:15.000000000 +0200
@@ -517,10 +517,18 @@
 #define TLS1_CK_ECDHE_RSA_WITH_AES_128_GCM_SHA256       0x0300C02F
 #define TLS1_CK_ECDHE_RSA_WITH_AES_256_GCM_SHA384       0x0300C030
 #define TLS1_CK_ECDH_RSA_WITH_AES_128_GCM_SHA256        0x0300C031
 #define TLS1_CK_ECDH_RSA_WITH_AES_256_GCM_SHA384        0x0300C032
 
+/* Ring-LWE based ciphersuites */
+#define TLS1_CK_RLWE_RSA_WITH_AES_128_GCM_SHA256        0x0300D000
+#define TLS1_CK_RLWE_ECDSA_WITH_AES_128_GCM_SHA256      0x0300D001
+#ifdef OPENSSL_HYBRID_RLWE_ECDHE
+#define TLS1_CK_RLWE_ECDHE_RSA_WITH_AES_128_GCM_SHA256        0x0300D002
+#define TLS1_CK_RLWE_ECDHE_ECDSA_WITH_AES_128_GCM_SHA256      0x0300D003
+#endif
+
 /* XXX
  * Inconsistency alert:
  * The OpenSSL names of ciphers with ephemeral DH here include the string
  * "DHE", while elsewhere it has always been "EDH".
  * (The alias for the list of all such ciphers also is "EDH".)
@@ -668,10 +676,17 @@
 #define TLS1_TXT_ECDHE_RSA_WITH_AES_128_GCM_SHA256      "ECDHE-RSA-AES128-GCM-SHA256"
 #define TLS1_TXT_ECDHE_RSA_WITH_AES_256_GCM_SHA384      "ECDHE-RSA-AES256-GCM-SHA384"
 #define TLS1_TXT_ECDH_RSA_WITH_AES_128_GCM_SHA256       "ECDH-RSA-AES128-GCM-SHA256"
 #define TLS1_TXT_ECDH_RSA_WITH_AES_256_GCM_SHA384       "ECDH-RSA-AES256-GCM-SHA384"
 
+#define TLS1_TXT_RLWE_RSA_WITH_AES_128_GCM_SHA256        "RLWE-RSA-AES128-GCM-SHA256"
+#define TLS1_TXT_RLWE_ECDSA_WITH_AES_128_GCM_SHA256      "RLWE-ECDSA-AES128-GCM-SHA256"
+#ifdef OPENSSL_HYBRID_RLWE_ECDHE
+#define TLS1_TXT_RLWE_ECDHE_RSA_WITH_AES_128_GCM_SHA256        "RLWE-ECDHE-RSA-AES128-GCM-SHA256"
+#define TLS1_TXT_RLWE_ECDHE_ECDSA_WITH_AES_128_GCM_SHA256      "RLWE-ECDHE-ECDSA-AES128-GCM-SHA256"
+#endif
+
 #define TLS_CT_RSA_SIGN			1
 #define TLS_CT_DSS_SIGN			2
 #define TLS_CT_RSA_FIXED_DH		3
 #define TLS_CT_DSS_FIXED_DH		4
 #define TLS_CT_ECDSA_SIGN		64
